'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var ngAnnotate = require('ng-annotate-patched');
var pluginutils = require('@rollup/pluginutils');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var ngAnnotate__default = /*#__PURE__*/_interopDefaultLegacy(ngAnnotate);

function annotatePlugin(opts) {
  let options = Object.assign({
    add: true,
    remove: false,
    es6: true
  }, opts.config || {});
  const filter = pluginutils.createFilter(opts.include || '**/*.js', opts.exclude || 'node_modules/**');
  return {
    name: 'ng-annotate',
    transform: (code, id) => {
      if (!filter(id)) {
        return null;
      }

      const output = ngAnnotate__default["default"](code, options);

      if (output.errors) {
        output.errors.forEach(error => {
          console.error(error);
        });
        return null;
      }

      return {
        code: output.src,
        map: {
          mappings: ''
        }
      };
    }
  };
}

exports["default"] = annotatePlugin;
